%%%%%%% 3D TOPOLOGY OPTIMIZATION %%%%%%%%%%%%%%%%
function BESO_3D_PP(nelx,nely,nelz,volfrac,er,rmin,newF,ft,fck,fyk)
% BESO_3D_PP(64,40,4,0.35,0.03,1.5,0,35,430) Cantilever
% BESO_3D_PP(60,10,10,0.20,0.03,1.5,0,35,430)  viga mbb
tic
%%%%%%%PARAMETROS DE LOOP DEFINIDOS PELO USUARIO %%%%%%%%
maxloop = 150;       %%numero maximo de iteracoes
tolx = 0.01;         %%criterio de parada
displayflag = 1;     %%Exibi videos na tela
comlim=340.01;
q=0.5;
p=10;
pl=3;
%%%%%%PROPRIEDADES DO MATERIAL - DEFINIDAS PELO USUARIO %%%%%
%E0 = 1.0; % E0=30088MPa=3008.8kN/cm
%%%%%%%%%TENSAO ADMISSIVEL DE COMPRESSAO DO CONCRETO %%%%%%%%%%%%%%%%%%%%%%
MPa= 1e-1; %N/mm
fcd = fck*MPa/1.4; %N/mm=1MPa=1e-1kN/cm2 fck=35.5MPa=35.5*10^-1kN/cm
%%%%%%%%%%%%%%%%%%%%%%%%FIM DE CALCULO %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%TENSAO ADMISSIVEL DE TRACAO DO CONCRETO%%%%%%%%%%%%%%%%%%%%%%%%
fyd = fyk*MPa/1.15; %N/mm²=1MPa=1e-3kN/mm2    fyk = 430 MPa =430*10^-3kN/mm
%%%%%%%%%%%%%%%%%%%%%%%%%%FIM DE CALCULO 
%%%%%%PROPRIEDADES DO MATERIAL - DEFINIDAS PELO USUARIO %%%%%
E0 = 1;             %%%modulo de Youg's para soolid material
Emin = 1e-5;        %%%modulo de Youg's para void-like material
%nu = 0.30;           %%%modulo de Poisson's
%%%%%%%%%%%%%%%%%%%%% CARREGAMENTO DEFINIDO PELO USUARIO %%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%PONTE COM TABULEIRO CENTRAL %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%[il,jl,kl] = meshgrid(0:nelx,nely/2 - 2,0:nelz); %carregamento tabuleiro central
%[il,jl,kl] = meshgrid(0:nelx,nely,0:nelz); %carregamento tabuleiro superior
%[il,jl,kl] = meshgrid(0:nelx,0,0:nelz);  %[0 nelz/2 nelz]
%%%%%%%%%%%%%%%%%%%%CARREGAMENTO DE PONTE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [il,jl,kl] = meshgrid(0:nelx,nely-18,0:nelz);
% loadnid = kl*(nelx+1)*(nely+1)+il*(nely+1)+(nely+1-jl);
% loaddof = 3*loadnid(:)-1;
% %%%%%%%%%%%%%%%%%%%%%%SUPORTES PARA PONTE%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [iif,jf,kf] = meshgrid(0,0,0:nelz);  
% fixednid = kf*(nelx+1)*(nely+1)+iif*(nely+1)+(nely+1-jf); % Node IDs
% fixeddof = [3*fixednid(:); 3*fixednid(:)-1; 3*fixednid(:)-2]; % DOFs
% % symmetry
% [iif,jf,kf] = meshgrid(nelx,0,0:nelz);  
% fixednid = kf*(nelx+1)*(nely+1)+iif*(nely+1)+(nely+1-jf); % Node IDs
% fixeddof = [fixeddof; 3*fixednid(:)-1; 3*fixednid(:)-2]; % DOFs
% %%%%%%%%%%%%%%%%%%TESTE MACA - PP %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [il,jl,kl] = meshgrid(nelx/2,nely,nelz/2); 
% loadnid = kl*(nelx+1)*(nely+1)+il*(nely+1)+(nely+1-jl); 
% loaddof = 3*loadnid(:) - 1;                             
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%SUPORTES DEFINIDOS PELO USUARIO%%%%%%%%%%%%
% [iif,jf,kf] = meshgrid(11,nely,11);
% fixednid = kf*(nelx+1)*(nely+1)+iif*(nely+1)+(nely+1-jf); 
% fixeddof = [3*fixednid(:); 3*fixednid(:)-1; 3*fixednid(:)-2]; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%CANTILEVER  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%jl = 0 mao francesa
%jl = nely/2 shorte cantilever
%jl = nely mao francesa invertida
% il=nelx; jl=nely/2; kl=0:nelz;
% loadnid = kl*(nelx+1)*(nely+1)+il*(nely+1)+(nely+1-jl);
% loaddof = 3*loadnid(:) - 1;
% %%%%%%%%%%%%%%%%%%%%%%SUPORTES DEFINIDOS PELO USUARIO %%%%%%%%%%%%%%%%%%%
% [jf,kf] = meshgrid(1:nely+1,1:nelz+1);
% fixednid = (kf-1)*(nely+1)*(nelx+1)+jf;
% fixeddof = [3*fixednid(:); 3*fixednid(:)-1; 3*fixednid(:)-2];
%%%%%%%%%%%%%%%%%%%%FIM DE CANTILEVER%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%VIGA MBB - CARREGAMENTO%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% il = nelx/2; jl=nelx; kl=nelz/2;
% loadnid = kl*(nelx+1)*(nely+1)+il*(nely+1)+(nely+1-jl);
% loaddof = 3*loadnid(:)-1;
% %%%%%%%%%%%%%%%%%%%%%SUPORTES PARA MBB%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% iif=[0 0 nelx nelx]; jf=[0 0 0 0]; kf=[0 nelz 0 nelz];
% fixednid = kf*(nelx+1)*(nely+1)+iif*(nely+1)+(nely+1-jf); % Node IDs
% fixeddof = [3*fixednid(:); 3*fixednid(:)-1; 3*fixednid(:)-2];
% fixeddof = fixeddof([1:8,11:12]);
%%%%%%%%%%%%%%%%%%%%CARREGAMENTO DE PONTE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[il,jl,kl] = meshgrid(0:nelx,nely/2,0:nelz);
loadnid = kl*(nelx+1)*(nely+1)+il*(nely+1)+(nely+1-jl);
loaddof = 3*loadnid(:)-1;
% %%%%%%%%%%%%%%%%%%%%%%SUPORTES PARA PONTE%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[iif,jf,kf] = meshgrid(ceil(nelx/8),0,0:nelz);  
fixednid = kf*(nelx+1)*(nely+1)+iif*(nely+1)+(nely+1-jf); % Node IDs
fixeddof1 = [3*fixednid(:); 3*fixednid(:)-1; 3*fixednid(:)-2]; % DOFs
% symmetry
[iif,jf,kf] = meshgrid(ceil(7*nelx/8),0,0:nelz);  
fixednid = kf*(nelx+1)*(nely+1)+iif*(nely+1)+(nely+1-jf); % Node IDs
fixeddof = [3*fixednid(:); 3*fixednid(:)-1; 3*fixednid(:)-2]; % DOFs
fixeddof = union(fixeddof1,fixeddof);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [iif,jf,kf] = meshgrid(0,0,0:nelz);  
% fixednid = kf*(nelx+1)*(nely+1)+iif*(nely+1)+(nely+1-jf); % Node IDs
% fixeddof1 = [3*fixednid(:); 3*fixednid(:)-1; 3*fixednid(:)-2]; % DOFs
% % symmetry
% [iif,jf,kf] = meshgrid(nelx,0,0:nelz);  
% fixednid = kf*(nelx+1)*(nely+1)+iif*(nely+1)+(nely+1-jf); % Node IDs
% fixeddof2 = [3*fixednid(:); 3*fixednid(:)-1; 3*fixednid(:)-2]; % DOFs
% fixeddof = union(fixeddof1,fixeddof2);
%%%%%%%%%%%%%%%%%%%%%%PREPARAR A AN ?LISE DE ELEMENTOS FINITOS %%%%%%%%%%%%%%%%%%
nele = nelx*nely*nelz;
ndof = 3*(nelx+1)*(nely+1)*(nelz+1);
F_ap = sparse(loaddof,1,newF,ndof,1);
U = zeros(ndof,1);
freedofs = setdiff(1:ndof,fixeddof);
[KE,B,D] = lk_H8();
nodegrd = reshape(1:(nely+1)*(nelx+1),nely+1,nelx+1);
nodeids = reshape(nodegrd(1:end-1,1:end-1),nely*nelx,1);
nodeidz = 0:(nely+1)*(nelx+1):(nelz-1)*(nely+1)*(nelx+1);
nodeids = repmat(nodeids,size(nodeidz))+repmat(nodeidz,size(nodeids));
edofVec = 3*nodeids(:)+1;
edofMat = repmat(edofVec,1,24)+...
    repmat([0 1 2 3*nely + [3 4 5 0 1 2 ] -3 -2 -1 ...
    3*(nely+1)*(nelx+1) + [0 1 2 3*nely + [3 4 5 0 1 2] -3 -2 -1]],nele,1);
iK = kron(edofMat, ones(24,1))';
jK = kron(edofMat, ones(1,24))';
%%%%%%%%%%%%%%%%%%%%% PREPARAR FILTRO %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
iH = ones(nele*(2*(ceil(rmin)-1)+1)^2,1);
jH = ones(size(iH));
sH = zeros(size(iH));
k = 0;
for k1 = 1:nelz
    for i1 = 1:nelx
        for j1 = 1:nely
	       e1 = (k1-1)*nelx*nely + (i1-1)*nely + j1;
            for k2 = max(k1-(ceil(rmin)-1),1):min(k1+(ceil(rmin)-1),nelz)
                for i2 = max(i1-(ceil(rmin)-1),1):min(i1+(ceil(rmin)-1),nelx)
                    for j2 = max(j1-(ceil(rmin)-1),1):min(j1+(ceil(rmin)-1),nely)
                    e2 = (k2-1)*nelx*nely + (i2-1)*nely+j2;
			        k = k+1;
			        iH(k) = e1;
			        jH(k) = e2;
			        sH(k) = max(0,rmin - sqrt((i1-i2)^2+(j1-j2)^2+(k1-k2)^2));
                    end
                end
           end
       end
     end
end
H = sparse(iH,jH,sH);
Hs = sum(H,2);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%INICIAR ITERACOES %%%%%%%%%%%%%%%%%%%%%%%%%
x = repmat(volfrac,[nely,nelx,nelz]);
loop = 0;
change = 1;
x(1:nely,1:nelx,1:nelz) = 1.;
vol=1.; 
criterio=1.;
%%%%%%%%%%%%%%%%%%%%%%INICIO DE ITERACAO %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%% MACA - PESO PROPRIO %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%passive = zeros(nely,nelx,nelz);
% for i = 1:nelx
%   for j = 1:nely
%       for k = 1:nelz
%           if (((i==10) || (i==13)) || ((k==10) || (k==13)))   
%               passive(j,i,k) = 1;  
%           end
%           if (i <= 9 || i > 13)
%               passive(j,i,k) = 0;
%           end
%           if (k <= 9 || k > 13)
%               passive(j,i,k) = 0;
%           end
%           if j > 5
%               passive(j,i,k) = 0;  
%           end
%           if j == 1
%               passive(j,i,k) = 1;  
%           end
%           if ((i>10 && i<13) && (k>10 && k<13))
%               passive(j,i,k) = 0; 
%           end
%       end
%   end
% end
% passive = repmat(passive,[1,1,nelz]);
% x(find(passive)) = 0; 
% xPhys = x;
%%%%%%%%%%%%%%%%%%%%%PONTE BURACO SEMI-CIRCULAR ACIMA DO PLANO y=2%%%%%%%%%
% % Definindo o raio do semi-crculo
% radius = 3;
% % Altura do plano onde o buraco semi-circular ser criado
% plane_y = 2;
% % Criando o buraco semi-circular
% for ely = 1:nely
%     for elz = 1:nelz
%         % Verificando se o ponto est acima do plano y=2
%         if ely > plane_y
%             % Aplicando a condio do buraco semi-circular
%             if sqrt((ely - (nely-2))^2 + (elz - nelz/2)^2) < radius
%                 passive(ely, elz) = 1;
%             else
%                 passive(ely, elz) = 0;
%             end
%         else
%             % Se o ponto est abaixo ou no plano y=2, no h buraco
%             passive(ely, elz) = 0;
%         end
%     end
% end
%  passive = repmat(passive,[nelx,1,1]);
%  x(find(passive)) = 0; 
 xPhys = x;
while change > tolx && loop < maxloop && criterio > tolx
loop = loop + 1; vol = max(vol*(1-er),volfrac);
if loop>1; olddc = dc; end
c(loop)=0.;
[F,F_sw]=selfweight(nelx,nely,nelz,xPhys,edofMat,F_ap);
%%%%%%%%%%%%%%%%%%%%ANALISE DE ELEMENTOS FINITOS%%%%%%%%%%%%%%%%
sK = KE(:)*(Emin+xPhys(:)'*(E0-Emin));
K = sparse (iK(:),jK(:),sK(:)); K = (K+K')/2;
%U(freedofs,:) = K(freedofs,freedofs)\F(freedofs,:);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%SOLVER ITERATIVO - GRADIENTE CONJUGADO-PRECONDIONADO%%%%%%%%
tolit = 1e-8;
maxit = 8000;
M = diag(diag(K(freedofs,freedofs)));
U(freedofs,:) = pcg(K(freedofs,freedofs),F(freedofs,:),tolit,maxit,M);
%%%%%%%%%%%% SOLVER ITERATIVO - CHOLESKY INCOMPLETO %%%%%%%%%%%%%%%%%%%%%%%
%L = ichol(K(freedofs,freedofs));
%U(freedofs,:) = pcg(K(freedofs,freedofs),F(freedofs,:),1e-8,1000,L,L');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%% VON_MISES STRESS VECTOR %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MISES=zeros(nele,1); 
    S=zeros(nele,6); 
 for i=1:nele
 temp=x(i)^q*(D*B*U(edofMat(i,:)))';
 S(i,:)=temp;
 MISES(i)=sqrt(0.5*((temp(1)-temp(2))^2+(temp(1)-temp(3))^2 ...
          +(temp(2)-temp(3))^2+6*sum(temp(4:6).^2)));
 end
 nele=size(x(:),1); %NÚMERO TOTAL DE ELEMENTOS
 [ndof,~]=size(U);
 DvmDs=zeros(nele,6);
 dpn_dvms=(sum(MISES.^p))^(1/p-1);
 index_matrix=edofMat';
 pnorm=(sum(MISES.^p))^(1/p);
 for i=1:nele
 DvmDs(i,1)=1/2/MISES(i)*(2*S(i,1)-S(i,2)-S(i,3));
 DvmDs(i,2)=1/2/MISES(i)*(2*S(i,2)-S(i,1)-S(i,3));
 DvmDs(i,3)=1/2/MISES(i)*(2*S(i,3)-S(i,1)-S(i,2));
 DvmDs(i,4)=3/MISES(i)*S(i,4);
 DvmDs(i,5)=3/MISES(i)*S(i,5);
 DvmDs(i,6)=3/MISES(i)*S(i,6); 
 end
 beta=zeros(nele,1);
 for i=1:nele
 u=reshape(U(edofMat(i,:),:)',[],1);
 beta(i)=q*(x(i))^(q-1)*MISES(i)^(p-1)*DvmDs(i,:)*D*B*u;
 end
 T1=dpn_dvms*beta;
 gama=zeros(ndof,1);
 for i=1:nele
 index=index_matrix(:,i);
 gama(index)=gama(index)+x(i)^q*dpn_dvms*B'*D'*DvmDs(i,:)'*MISES(i).^(p-1);
 end
 lamda=zeros(ndof,1);
 lamda(freedofs,:)=K(freedofs,freedofs)\gama(freedofs,:);
 T2=zeros(nele,1);
 for i=1:nele
 index=index_matrix(:,i);
 T2(i)=-lamda(index)'*pl*x(i)^(pl-1)*KE*U(index);
 end
 pnorm_sen=T1+T2;
 %%%%%%%%%%%%%% VON_MISES STRESS VECTOR %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 MISES=zeros(nele,1); 
 T_C=zeros(nele,1);
 for i=1:nele
     
         if DvmDs(i,1)>=0
            T_C(i) = 1; %tirante
         end
         if  DvmDs(i,3)<0
            T_C(i) = -1; %biela
         end
            
 end 
%%%%%%%%%%%%ANALISE DA SENSIBILIDADE E FUNÇÃO OBJETIVO%%%%%%%%%%
ce = reshape(sum((U(edofMat)*KE).*U(edofMat),2),[nely,nelx,nelz]);
c(loop) = c(loop) + sum(sum(sum((Emin +xPhys*(E0-Emin)).*ce)));
dc = -(E0-Emin).*(xPhys).*ce;
dv = ones(nely,nelx,nelz);
%%%%%%%%%%%%%%%FILTRO DENSIDADE OU DE SENSIBILIDADE%%%%%%%%%%%%%%%%%%%%%%%
if ft==1       
  	dc(:) = H*(dc(:)./Hs);        
  	dv(:) = H*(dv(:)./Hs);    
 	elseif ft==2        
 	dc(:) = H*(x(:).*dc(:))./Hs./max(1e-3,x(:)); 
end   
%%%%%%%%%%%%FILTRANDO E MODIFICANDO A SENSIBILIDADE%%%%%%%%%%%%%
l1 = 0; l2 = 1e9; move = 0.2;
while (l2-l1)/(l1+l2)>1e-3
     lmid = 0.5*(l2+l1);
     xnew = max(0,max(x-move,min(1,min(x+move,x.*sqrt(-dc./dv/lmid)))));
     if ft == 1
        xPhys(:) = (H*xnew(:))./Hs;
        elseif ft == 2
        xPhys = xnew;
     end
     if sum(xPhys(:)) > vol*nele, l1 = lmid; else l2 = lmid; end
end
change = max(abs(xnew(:)-x(:)));
% STABLIZATION OF EVOLUTIONARY PROCESS
[dc]   = check(nelx,nely,nelz,rmin,dc);
if loop > 1; dc = (dc+olddc)/2.; end 
% BESO DESIGN UPDATE
[x]=ADDDEL(nelx,nely,nelz,vol,dc,x);
% xnew(find(passive)) = 0;
x = xnew;
%%%%%%%%%%%%%%%%%%IMPRESSAO DE RESULTADOS%%%%%%%%%%%%%%%%%%%%%%%
fprintf(' it.:%5i OBj.:%11.4f Vol.:%7.3f ch.:%7.3f\n',loop,c(loop),mean(xPhys(:)),change);
%% CRIAR VETORES PARA OS GRAFICOS
TC = reshape(T_C,nely,nelx,nelz);
com(loop) = c(loop);
volume(loop) =  double(mean(xPhys(:)));
%%%%%%%%%%%%%INDICE DE PERFORMANCE%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for jk=1:loop 
   pi=(com(1)*volume(1))/(com(jk)*volume(jk));
end
%if (pi < 1 ); break; end;
id(loop)= pi;
%%%%%%%%%%%%%%%%%%%CRITERIO DE PARADA%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 if loop>120
   criterio=abs((sum(com((loop-1)-9:(loop-1)-5))-sum(com((loop-1)-4:...
   (loop-1))))/sum(com((loop-1)-4:(loop-1))));
 end
%%%%%%%%%%RESTRICAO DE COMPRESSAO E TRACAO %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j=1:nele
    if (abs(DvmDs(j,1))-fcd) < 0.001; break; end;
    if (abs(DvmDs(j,3))-fyd) < 0.001; break; end;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%RESTRICAO DE COMPLIANCE%%%%%%%%%%%%%%%%%%%%%%
 if ((max(com(loop))-comlim) < 0.001 && loop > 90); break; end;
%%%%%%%%%%%%%%%%%ESBOA ESTRUTURA%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if displayflag, 
    clf; 
    display_3D(xPhys);
    display_Mises(xPhys);
    clf; plot_T_C(xPhys,reshape(T_C,nely,nelx,nelz));
   % displayGraph(com,volume,loop-1,id);

end
end
    clf; 
    display_3D(xPhys);
    display_Mises(xPhys);
    clf;plot_T_C(xPhys,reshape(T_C,nely,nelx,nelz));
 %   displayGraph(com,volume,loop-1,id);
    toc
end
%%%%%%%%%%%%%%%%%%%%FUNCOES AUXILIARES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%GERAR ELMENTO DA MATRIZ DE RIGIDEZ%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [KE,B,D] = lk_H8()
 nu=0.30;
 D = 1./((1+nu)*(1-2*nu))*[1-nu nu nu 0 0 0; nu 1-nu nu 0 0 0;...
 nu nu 1-nu 0 0 0; 0 0 0 (1-2*nu)/2 0 0; 0 0 0 0 (1-2*nu)/2 0;...
 0 0 0 0 0 (1-2*nu)/2];

A = [32 6 -8 6 -6 4 3 -6 -10 3 -3 -3 -4 -8;
    -48 0 0 -24 24 0 0 0 12 -12 0 12 12 12];
k = 1/144*A'*[1; nu];

K1 = [k(1) k(2) k(2) k(3) k(5) k(5);
    k(2) k(1) k(2) k(4) k(6) k(7);
    k(2) k(2) k(1) k(4) k(7) k(6);
    k(3) k(4) k(4) k(1) k(8) k(8);
    k(5) k(6) k(7) k(8) k(1) k(2);
    k(5) k(7) k(6) k(8) k(2) k(1)];
K2 = [k(9)  k(8)  k(12) k(6)  k(4)  k(7);
    k(8)  k(9)  k(12) k(5)  k(3)  k(5);
    k(10) k(10) k(13) k(7)  k(4)  k(6);
    k(6)  k(5)  k(11) k(9)  k(2)  k(10);
    k(4)  k(3)  k(5)  k(2)  k(9)  k(12)
    k(11) k(4)  k(6)  k(12) k(10) k(13)];
K3 = [k(6)  k(7)  k(4)  k(9)  k(12) k(8);
    k(7)  k(6)  k(4)  k(10) k(13) k(10);
    k(5)  k(5)  k(3)  k(8)  k(12) k(9);
    k(9)  k(10) k(2)  k(6)  k(11) k(5);
    k(12) k(13) k(10) k(11) k(6)  k(4);
    k(2)  k(12) k(9)  k(4)  k(5)  k(3)];
K4 = [k(14) k(11) k(11) k(13) k(10) k(10);
    k(11) k(14) k(11) k(12) k(9)  k(8);
    k(11) k(11) k(14) k(12) k(8)  k(9);
    k(13) k(12) k(12) k(14) k(7)  k(7);
    k(10) k(9)  k(8)  k(7)  k(14) k(11);
    k(10) k(8)  k(9)  k(7)  k(11) k(14)];
K5 = [k(1) k(2)  k(8)  k(3) k(5)  k(4);
    k(2) k(1)  k(8)  k(4) k(6)  k(11);
    k(8) k(8)  k(1)  k(5) k(11) k(6);
    k(3) k(4)  k(5)  k(1) k(8)  k(2);
    k(5) k(6)  k(11) k(8) k(1)  k(8);
    k(4) k(11) k(6)  k(2) k(8)  k(1)];
K6 = [k(14) k(11) k(7)  k(13) k(10) k(12);
    k(11) k(14) k(7)  k(12) k(9)  k(2);
    k(7)  k(7)  k(14) k(10) k(2)  k(9);
    k(13) k(12) k(10) k(14) k(7)  k(11);
    k(10) k(9)  k(2)  k(7)  k(14) k(7);
    k(12) k(2)  k(9)  k(11) k(7)  k(14)];
KE = 1/((nu+1)*(1-2*nu))*...
    [ K1  K2  K3  K4;
    K2'  K5  K6  K3';
    K3' K6  K5' K2';
    K4  K3  K2  K1'];
%%%%%%%%%%%%%%%% FORMULAÇÃO DA MATRIZ DE DEFORMAÇÃO%%%%%%%%%%%%%%%%%%%%%%%%
 B_1=[-0.044658,0,0,0.044658,0,0,0.16667,0
 0,-0.044658,0,0,-0.16667,0,0,0.16667
 0,0,-0.044658,0,0,-0.16667,0,0
 -0.044658,-0.044658,0,-0.16667,0.044658,0,0.16667,0.16667
 0,-0.044658,-0.044658,0,-0.16667,-0.16667,0,-0.62201
 -0.044658,0,-0.044658,-0.16667,0,0.044658,-0.62201,0];
 B_2=[0,-0.16667,0,0,-0.16667,0,0,0.16667
 0,0,0.044658,0,0,-0.16667,0,0
 -0.62201,0,0,-0.16667,0,0,0.044658,0
 0,0.044658,-0.16667,0,-0.16667,-0.16667,0,-0.62201
 0.16667,0,-0.16667,0.044658,0,0.044658,-0.16667,0
 0.16667,-0.16667,0,-0.16667,0.044658,0,-0.16667,0.16667];
 B_3=[0,0,0.62201,0,0,-0.62201,0,0
 -0.62201,0,0,0.62201,0,0,0.16667,0
 0,0.16667,0,0,0.62201,0,0,0.16667
 0.16667,0,0.62201,0.62201,0,0.16667,-0.62201,0
 0.16667,-0.62201,0,0.62201,0.62201,0,0.16667,0.16667
 0,0.16667,0.62201,0,0.62201,0.16667,0,-0.62201];
 B=[B_1,B_2,B_3];
end
%%%%%%%%%%%%%%%%EXIBIR TOPOLOGIA 3D %%%%%%%%%%%%%%%%%
function display_3D(rho)

[nely,nelx,nelz] = size(rho);
% figure(7);
% aa = squeeze(rho(:,:,4));
% contour(1:nelx,1:nely,aa);
% 
% figure (8);
% surf(1:nelx,1:nely,aa);

figure(1);

hx = 1; hy = 1; hz = 1;   %%%definicao do usuario para elemento unitario%%%
face = [1 2 3 4; 2 6 7 3; 4 3 7 8; 1 5 8 4; 1 2 6 5; 5 6 7 8];
set(gcf,'Name','ISO display','NumberTitle','off');
for k=1:nelz
    z=(k-1)*hz;
    for i = 1:nelx
        x = (i-1)*hx;
        for j = 1:nely
            y = nely*hy - (j-1)*hy;
   %         fprintf('%5i;%5i;%5i;%7.3f\n',i,j,k,rho(j,i,2));
             % if (rho(j,i,k)>0.5 || (j>=0) && (j<=nely-38))  %tabuleiro superior 
           % if (rho(j,i,k)>0.5) || ((j>=nely-2) && (j<=nely)) %tabuleiro INFERIOR
             if (rho(j,i,k)>0.5)  || ((j>=nely/2) && (j<=nely/2+1)) %tabuleiro central
                vert = [x y z; x y-hx z; x+hx y-hx z; x+hx y z; x y z+hx; x y-hx z+hx;... 
                    x+hx y-hx z+hx; x+hx y z+hx];
                vert ( : , [ 2 3 ] ) = vert ( : , [ 3 2 ] ) ; vert (:,2,:) = vert(:,2,:);
                %% cor azul
 %               f = [0,0,1];
 %               if (rho(j,i,k) > 0.8)
                    %% cor vermelha
 %                  f =[1,0,0];
 %               else
 %                   if( rho(j,i,k) > 0.6)
                        %%cor verde
 %                       f =[0,1,0];
 %                   end
%               end
                 patch ('Faces', face,'Vertices', vert, 'FaceColor',[1,0,0])              
%                patch ('Faces', face,'Vertices', vert, 'FaceColor',f)
%                patch ('Faces', face,'Vertices', vert, 'FaceColor',[0.2+0.8*(1-rho(j,i,k))...
%                      ,0.2+0.8*(1-rho(j,i,k)),0.2+0.8*(1-rho(j,i,k))])
                hold on;
            end
        end
    end
end
%colorbar
axis equal; axis tight; axis off; box on; view([30,30]);pause (1e-6);
end
%%%%%%%%%% OPTIMALITY CRITERIA UPDATE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [x]=ADDDEL(nelx,nely,nelz,volfrac,dc,x)
l1 = min(min(min(dc))); l2 = max(max(max(dc)));
while ((l2-l1)/l2 > 1.0e-5)
     th = (l1+l2)/2.0;
     x = max(0.001,sign(dc-th));
     if sum(sum(sum(x)))-volfrac*(nelx*nely*nelz) > 0;
        l1 = th;
     else
        l2 = th;
     end
end
end
%%%%%%%%%% MESH-INDEPENDENCY FILTER %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [dcf]=check(nelx,nely,nelz,rmin,dc)
dcf=zeros(nely,nelx,nelz);
for p=1:nelz
for i = 1:nelx
  for j = 1:nely
    sum=0.0; 
    for m = max(i-floor(rmin),1):min(i+floor(rmin),nelz)
    for k = max(i-floor(rmin),1):min(i+floor(rmin),nelx)
      for l = max(j-floor(rmin),1):min(j+floor(rmin),nely)
       fac = rmin-sqrt((i-k)^2+(j-l)^2+(p-m)^2);
       sum = sum+max(0,fac);
       dcf(j,i,p) = dcf(j,i,p) + max(0,fac)*dc(l,k,m);
      end
    end
    end
    dcf(j,i,p) = dcf(j,i,p)/sum;
  end
end
end
end
%%%%%%%%%%%%%%%%%%%%%%%funcao para grafico%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%funcao para esbocar grafico de volume, complience x iteracao
function displayGraph(com,volume,loop,id) 
    figure(2);
    plot(com(2:loop),'rd--', 'linewidth', 2); 
    xlabel('i')
    ylabel('Compliance')
    title('Compliance');
  
    figure(3);
    plot(volume(2:loop),'b--o', 'linewidth', 2); 
    xlabel('i')
    ylabel('Volume')
    title('Volume fraction');
    
    figure(4);
    volume = volume / volume(1);
    com = com / com(1);
    plot(com,volume,'k--o', 'linewidth', 2);
    xlabel('Ci/Co')
    ylabel('Vi/Vo')
    title('Vi/Vo por Ci/Co ');
    
    figure(5);
    plot(id(2:loop-1),'k--o', 'linewidth',2);
    xlabel('i')
    ylabel('pi') 
    title('Performance Index ');
end
%%%%%%%%%%%%%%%%%%%%%%PLOTA TENS O VON_MISES%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%PLOTA TENS O VON_MISES%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [] = display_Mises(rho)
    figure(12);
    [nely, nelx, nelz] = size(rho);
    
    %%%%%%%%%%%%%%%TABULEIRO CENTRAL  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for k=1:nelz
        for i = 1:nelx
            for j = 1:nely
                if ((j>=nely/2) && (j<=nely/2+2)) %tabuleiro central
                    rho(j,i,k) = 1;
                end
            end
        end
    end
% %%%%%%%%%%%%%%%TABULEIRO SUPERIOR %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% for k=1:nelz
%     for i = 1:nelx
%         for j = 1:nely
%              if ((j>=0) && (j<=nely-38)) 
%                   rho(j,i,k) = 1;
%              end
%         end
%      end
% end
% % % %%%%%%%%%%%%%%%TABULEIRO INFERIOR%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% for k=1:nelz
%     for i = 1:nelx
%         for j = 1:nely
%              if ((j>=nely-2) && (j<=nely)) 
%                   rho(j,i,k) = 1;
%              end
%         end
%      end
% end

    fv = isosurface(rho, 0.5);
    [F1, V1] = isosurface(rho, 0.5);
    [F2, V2] = isocaps(rho, 0.5);

    % Verifica se V1 no est vazio antes de acessar seus elementos
    if ~isempty(V1)
        F3 = [F1; F2 + size(V1, 1)];
        V3 = [V1; V2];
        fv.vertices = V3;
        fv.faces = F3;

        p = patch(fv);
        cdata = rho;
        isocolors(cdata, p);
        p.FaceColor = 'interp';
        p.EdgeColor = 'none';
        camlight('headlight');
        lighting('phong');
        material([0.3, 0.6, 1, 15, 1.0]);
        axis equal;
        axis off;
        colormap('jet');
        drawnow;
    else
        disp('Iso-surface not found for the given threshold.');
    end
end
function [] = plot_T_C(density, T_C)
figure(11);

[nely, nelx, nelz] = size(density);

%Ajuste para ns dentro um elemento de distncia em todas as direes
raio = 3;
for x = 1:nelx
    %intervalos
    if x > raio && x < (nelx)-raio
        xi = (x-raio:x+raio);
    else
        if x <= raio
            xi = (x:x+raio);
        else % e a outra borda
            xi = (x-raio:x);
        end
    end
    for y = 1:nely
        %intervalos
        if y > raio && y < (nely)-raio
            yi = (y-raio:y+raio);
        else
            if y <= raio
                yi = (y:y+raio);
            else % e a outra borda
                yi = (y-raio:y);
            end
        end
        for z = 1:nelz
            %intervalos
            if z > raio && z < (nelz)-raio
                zi = (z-raio:z+raio);
            else
                if z <= raio
                    zi = (z:z+raio);
                else % e a outra borda
                    zi = (z-raio:z);
                end
            end
            %% busca a moda dos elementos com raio de distncia
            T_C(y,x,z) = mode(mode(mode(T_C(yi,xi,zi))));
        end
    end
end

%%%%%%%%%%%%%%%%TABULEIRO CENTRAL %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for x = 1:nelx
    for y = (nely/2):(nely/2+2)
        for z = 1:nelz
            density(y, x, z) = 1;  %tabuleiro central
            T_C(y, x, z) = -1;
        end
    end
end

% % %%%%%%%%%%%%%%%TABULEIRO SUPERIOR %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% for x = 1:nelx
%     for y = 1:(nely-58)
%         for z = 1:nelz
%             density(y, x, z) = 1;  %tabuleiro superior
%             T_C(y, x, z) = -1;
%         end
%     end
% end
% %%%%%%%%%%%%%%%TABULEIRO INFERIOR %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% for x = 1:nelx
%     for y = nely-2:nely
%         for z = 1:nelz
%             density(y, x, z) = 1;  %tabuleiro inferior
%             T_C(y, x, z) = -1;
%         end
%     end
% end

fv = isosurface(density, 0.5);
[F1, V1] = isosurface(density, 0.5);
[F2, V2] = isocaps(density, 0.5);
F3 = [F1; F2 + size(V1, 1)];
V3 = [V1; V2];
fv.vertices = V3;
fv.faces = F3;
p = patch(fv);
cdata = T_C;
isocolors(cdata, p)
p.FaceColor = 'interp';
p.EdgeColor = 'none';

% Color map
map_color = [1, 0, 0;  % Red
             0, 0, 1]; % Blue
colormap(map_color);

view([30, 130]); 
axis equal off; 
lighting gouraud;
drawnow;
end