%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%RELIABILITY-BASED TOPOLOGY OPTIMIZATION%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function rbto_BESO_3D(nelx,nely,nelz,volfrac,er,rmin,Bet,E0,ft,comlim,fck,fyk)
%%%%%PONTE - BURACO DIRECAO X - rbto_BESO_3D(116,20,12,0.30,0.03,1.5,3,1,1,49.98,35,500)%%%
%%%%%%%%%%%VETOR U: U = [-3 1. 4. -2. -4. 1. 3.]; %%%%%%%%%%%%%%%%%%%%%%%%%
U = [-3 1. 4. -2. -4. 1. 3.];
oldnelx = nelx; oldnely = nely; oldnelz = nelz;
d = sqrt(U(1)^2 + U(2)^2 + U(3)^2 + U(4)^2 + U(5)^2 + U(6)^2 + U(7)^2); 
lop = 0; lops = 0; lp = 0; loops=0; 
diff = d - Bet; 
%%%%%%%%%%%%%%%%%%%%INICIAR ITERAES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
alpha = 1.; 
while diff > 0.01 
    lp = lp + 1; 
    [Z]=U; 
    [dDdU] = [U(1)/d U(2)/d U(3)/d U(4)/d U(5)/d U(6)/d U(7)/d]; 
    [U] = U - alpha*dDdU; 
    d = sqrt(U(1)^2 + U(2)^2 + U(3)^2 + U(4)^2 + U(5)^2 + U(6)^2 + U(7)^2);  
    if d<Bet; 
        [U] = Z; 
        alpha = alpha/2; 
    else
        alpha = alpha;
    end
    d = sqrt(U(1)^2 + U(2)^2 + U(3)^2 + U(4)^2 + U(5)^2 + U(6)^2 + U(7)^2);  
    diff = d-Bet; 
    [dDdU] =[U(1)/d U(2)/d U(3)/d U(4)/d U(5)/d U(6)/d U(7)/d];  
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%NELX - VARIAVEL%%%%%%%%%%%%%%%%%%%%%%
mnelx = nelx*(1+0.1*U(2)); 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
while mnelx-nelx >= 1 
    lop = lop + 1; 
    nelx = nelx + 1; 
end
if mnelx-nelx >= 0.5 
    nelx = nelx + 1; 
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%NELY - VARIAVEL%%%%%%%%%%%%%%%%%%%%%%
mnely = nely*(1+0.1*U(3));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
while nely-mnely >= 1 
    lops = lops + 1; 
    nely = nely-1;
end
if nely-mnely >= 0.5 
    nely = nely-1; 
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%NELZ - VARIAVEL%%%%%%%%%%%%%%%%%%%%%%
mnelz = nelz*(1+0.1*U(4));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
while nelz-mnelz >= 1 
    loops = loops + 1; 
    nelz = nelz-1;
end
if nelz-mnelz >= 0.5 
    nelz = nelz-1; 
end
%%%%%%%%%%%%%%%%%%%%MANTEM MALHA PAR%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nelx%2 == 1
   nelx = floor(nelx/2)*2; 
end
if nely%2 == 1
   nely = floor(nely/2)*2; 
end
if nelz%2 == 1
   nelz = floor(nelz/2)*2; 
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
U = [-3. (nelx-oldnelx)/0.1/oldnelx (nely-oldnely)/0.1/oldnely ...
    (nelz-oldnelz)/0.1/oldnelz -4. 1. 3.]; 
d = sqrt(U(1)^2 + U(2)^2 + U(3)^2 + U(4)^2 + U(5)^2 + U(6)^2 + U(7)^2);  
diff = d-Bet;
[dDdU] = [U(1)/d U(2)/d U(3)/d U(4)/d U(5)/d U(6)/d U(7)/d]; 
alpha = 1.; 
while diff > 0.01 
    lp = lp + 1; 
    [Z]=U; 
    [dDdU] = [U(1)/d U(2)/d U(3)/d U(4)/d U(5)/d U(6)/d U(7)/d];
    [U] = U-alpha*dDdU; 
    d = sqrt(U(1)^2 + U(2)^2 + U(3)^2 + U(4)^2 + U(5)^2 + U(6)^2 + U(7)^2);   
    if d<Bet; 
        [U] = Z; 
        alpha = alpha/2; 
    else
        alpha = alpha; 
    end
    d = sqrt(U(1)^2 + U(2)^2 + U(3)^2 + U(4)^2 + U(5)^2 + U(6)^2 + U(7)^2);  
    diff = d - Bet;
    [dDdU] = [U(1)/d U(2)/d U(3)/d U(4)/d U(5)/d U(6)/d U(7)/d];
end
newF = -1*(1+0.1*U(1));
volfrac = volfrac*(1+0.1*U(5));
E0 = E0*(1-0.1*U(6));
comlim = comlim*(1-0.1*U(7));
disp([' Iteraes FORM =' sprintf('%2.3f ',lop)])
disp([' For Beta =' sprintf('%2.3f ',d)])
disp([' var Aleatria FORA =' sprintf('%2.3f ',newF)...
  ' var Aleatria NELX =' sprintf('%2.3f ',nelx)...
  ' var Aleatria NELY =' sprintf('%2.3f ',nely)...
  ' var Aleatria NELZ =' sprintf('%2.3f ',nelz)])
disp([' var Aleatria VF =' sprintf('%2.3f ',volfrac)...
  ' var Aleatria Mod Elas =' sprintf('%2.3f ',E0)...
  ' var Aleatria compliance =' sprintf('%2.3f ',comlim)])
disp([' U(1) = ' sprintf('%2.3f ',U(1)) ...
' U(2) = ' sprintf('%2.3f ',U(2)) ...
' U(3) = ' sprintf('%2.3f ',U(3)) ...
' U(4) = ' sprintf('%2.3f ',U(4))...
' U(5) = ' sprintf('%2.3f ',U(5))...
' U(6) = ' sprintf('%2.3f ',U(6))...
' U(7) = ' sprintf('%2.3f ',U(7))])
calculateCDF(Bet);
%%%%%%%%%CALL OF TOPOLOGY OPTIMIZATION FUNCTION%%%%%%%%%%%%%%%%%%%%%%%%%%%%
BESO_3DTO(nelx,nely,nelz,volfrac,er,rmin,newF,ft,fck,fyk)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
